%
% Compute the Pbootstrap from Pcomplet
% If Pcomplet is in Mrond:
% - compute distance to frontier
% - project P on frontier
% - Pbootstrap: linear combination of Pcomplet and projected P
% Case: Pooling Ks (not necessarily independent from p)
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function [Pbootstrap,indic_frontiere] = Pchap_to_Pbootstrap(Pcomplet,n,bornes_Theil,xp1)

    K = length(Pcomplet)-1;
    
    % On calcule d'abord une "distance"  la frontire base sur
    % borne_Theil_sup - borne_Theil_inf. On fait qqs bootstrap pr
    % calculer l'cart-type de cette variable.
    nb_boot_init = 2e2 ;
    bornes_Theil_boot_init = zeros(2,nb_boot_init);
    contraint_boot = 1;
    bb = 1;
            
    % Double critre : au moins nb_boot_init itrations ET au moins une fois 
    % l'intrieur
    while bb < nb_boot_init  || contraint_boot ==1 
                
        count_boot = mnrnd(n,Pcomplet);
        Ptilde_boot = count_boot(2:end)'/n;
        [Pchap_boot,contraint_boot,xp_boot] = fct_Pchap_CML(Ptilde_boot,xp1);        
        mchap_boot = fct_Q(K) \ Pchap_boot;
        bornes_Theil_boot_init(:,bb) = estimation_bornes_Theil_cheb(mchap_boot, xp_boot, contraint_boot); 
        bb = bb+1;

    end
           
    distance_frontiere = (bornes_Theil(2)-bornes_Theil(1))/...
        (sqrt(2*log(log(sum(n)))) * std(bornes_Theil_boot_init(2,:)-bornes_Theil_boot_init(1,:))); 

    % Cas o on est proche du bord : on projete mchap sur la
    % frontire
    if (distance_frontiere<1)
        indic_frontiere = 1;
        Pbootstrap = proj_frontiere2(Pcomplet, n);
    else 
        indic_frontiere = 0;
        Pbootstrap = Pcomplet;
    end
    
end
