%
% Bootstrap estimation of the alternative indices
% First row of the output is on the whole sample
% following rows: one by bootstrap iteration
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function mat = alternatives_Kindep_CI(db, vect_K, nboot)

    vec = alternatives_Kindep(db, vect_K);
    mat_boot=zeros(nboot,length(vec));
    nb_K = length(vect_K);

    % Eliminating irrelevant observations
    db=db(db(:,1)>-99,:);
    nK=zeros(nb_K,1);

    Pstacke=zeros(sum(vect_K),1);
    compteur = 1 ;
    for kk=1:nb_K
        K = vect_K(kk);
        [val,iiii] = min(db');
        count = db( (iiii-2 == K)&(val==-99) ,:);
        count = count(count>-99);
        nK(kk) = sum(count);
        Pstacke(compteur:compteur+K-1)=count(2:end)/sum(count);
        compteur= compteur + K ;
    end

    for jj = 1:nboot

        % Tirage echantillon avec remise meme taille
        db_boot = db*0-99;
        vect_nk = mnrnd(sum(nK),nK/sum(nK));
        compteur = 1 ;
        for kk=1:length(vect_K)
            K = vect_K(kk);
            Pcomplet = [1-sum(Pstacke(compteur:compteur+K-1)); Pstacke(compteur:compteur+K-1)]; 
            compteur= compteur + K ;
            count_boot = mnrnd(vect_nk(kk),Pcomplet);
            db_boot((iiii-2 == K)&(val==-99),1:length(count_boot))=count_boot;
        end

        % Estimation des bornes
        mat_boot(jj,:) = alternatives_Kindep(db_boot, vect_K);

    end
    
    % Find the quantiles
    CI_inf = quantile(mat_boot,.025,1);
    CI_sup = quantile(mat_boot,.975,1);
    mat = [vec;CI_inf;CI_sup];

end
