%
% Bounds of the Theil index
% Function providing E[h(X)] when the support points of X is the vector x
%   of dim K+1, with the first K moments of X set to m
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function res = borne_Theil(xp, m1, signe)

x = xp(1:end/2);
p = xp(end/2+1:end);
if isempty(m1)
   m1 = x' * p; 
end
res = signe * (1-  xlnx(x)/xlnx(m1))'  * p;

