%
% Conditional index based on a dichotomic characteristic on workers
% Updated May 2016
% Xavier d'Haultfoeuille and Roland Rathelot
% 

function bcidot = conditional_index(bci1,bci2,db1,db2)

%%% compute the weights: share of workers in each category
[~,iiii] = min(db1');
Kvec1 = iiii-2;
[~,iiii] = min(db2');
Kvec2 = iiii-2;

dbb1 = (db1+abs(db1))/2; 
dbb2 = (db2+abs(db2))/2; 
N1 = sum(Kvec1*dbb1);
N2 = sum(Kvec2*dbb2);
w = N1/(N1+N2);

%%% keep only bounds and CI for unweighted index (both Theil and Duncan)
b1 = bci1(1,2:5);
b2 = bci2(1,2:5);
ci1 = bci1(1,7:10);
ci2 = bci2(1,7:10);

%%% build bounds and CI for the conditional index
dist_b_ci1 = b1-ci1;
dist_b_ci2 = b2-ci2;
dist_b_ci = w*dist_b_ci1+(1-w)*dist_b_ci2;

bdot = w*b1+(1-w)*b2;
cidot = bdot - dist_b_ci; 
bcidot = [bdot cidot];

end