%
% Estimation of the bounds of the Theil index (Chebyshev method), 
%   pooling Ks
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function bornes = estimation_bornes_Theil_cheb_Krandom(m0, xp_constr,contraint, m01)

% Unconstrained case
if contraint ==0

    K = length(m0);
    L=floor((K+1)/2);

    if L == K/2
        % Cas pair
        m0_1 = m0(1:L);
        m0_2 =  m0(L+1:2*L);
        Mat_mom_l = hankel(m0_1,m0(L:2*L-1));
        if K==2
            Mat_mom_u = 1 - Mat_mom_l ;
        else
            m0_0 = [1;m0(1:L-1)];
            Mat_mom_u = hankel(m0_0,m0(L-1:2*L-2)) - Mat_mom_l ;
        end
        for_poly_orth_l = - Mat_mom_l \ m0_2 ;
        coeff_poly_ort_l = [1, fliplr(for_poly_orth_l')]; 
        x_lower = sort([0; roots(coeff_poly_ort_l)]);

        for_poly_orth_u = - Mat_mom_u \ (m0(L:2*L-1)-m0_2);
        coeff_poly_ort_u = [1, fliplr(for_poly_orth_u')]; 
        x_upper = sort([roots(coeff_poly_ort_u);1]);
        vandermonde_l = repmat(x_lower', L+1,1).^repmat((0:L)',1,L+1); 
        proba_lower =  vandermonde_l \ [1;m0_1];

        vandermonde_u = repmat(x_upper', L+1,1).^repmat((0:L)',1,L+1); 
        proba_upper =  vandermonde_u \ [1;m0_1];

        Theil_upper = (1-  xlnx(x_lower)/xlnx(m01))'  * proba_lower;
        Theil_lower = (1-  xlnx(x_upper)/xlnx(m01))'  * proba_upper;

        bornes = [Theil_lower; Theil_upper];
        
    else
        % Cas impair

        m0_1_l = [1;m0(1:L-1)];
        m0_11_u = m0(1:L-1);
        m0_12_u = m0(2:L);
        m0_2_l =  m0(L-1:2*L-2);
        m0_21_u =  m0(L-1:2*L-3);
        m0_22_u =  m0(L:2*L-2);
        Mat_mom_l = hankel(m0_1_l, m0_2_l);
        Mat_mom_u = hankel(m0_11_u,m0_21_u) - hankel(m0_12_u,m0_22_u) ;
        for_poly_orth_l = - Mat_mom_l \ m0(L:2*L-1) ;
        coeff_poly_ort_l = [1, fliplr(for_poly_orth_l')]; 
        x_lower = sort(roots(coeff_poly_ort_l));

        for_poly_orth_u = - Mat_mom_u \ (m0_22_u-m0(L+1:2*L-1));
        coeff_poly_ort_u = [1, fliplr(for_poly_orth_u')]; 
        x_upper = sort([0;roots(coeff_poly_ort_u);1]);

        vandermonde_l = repmat(x_lower', L,1).^repmat((0:L-1)',1,L); 
        proba_lower =  vandermonde_l \ m0_1_l;

        vandermonde_u = repmat(x_upper', L+1,1).^repmat((0:L)',1,L+1); 
        proba_upper =  vandermonde_u \ [1;m0(1:L)];


        Theil_lower = (1-  xlnx(x_lower)/xlnx(m01))'  * proba_lower;
        Theil_upper = (1-  xlnx(x_upper)/xlnx(m01))'  * proba_upper;

        bornes = [Theil_lower; Theil_upper];

    end
    
        % Constrained case
    else
       bornes = repmat( borne_Theil(xp_constr, m01, 1),2,1);

end