%
% Compute CI of the bounds, after bootstrap has been made
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
%  

function [bornesIC,bornesICint,bornesICext] = fct_compute_CI(bornes,bornes_boot,distance_frontier)

    % Compute the CI in the different cases
    alp=.05;
    Theil_middle = mean(bornes(2:3));
    Duncan_middle = mean(bornes(4:5));

    bornesICext = zeros(1,length(bornes));
    bornesICint = zeros(1,length(bornes));
    bornesICext(1) = distance_frontier;
    bornesICint(1) = distance_frontier;
    
    % If interior close to frontier or exterior (contraint)
    quant_Theil = quantile(abs(mean(bornes_boot(:,2:3),2) - Theil_middle) ,1-alp);
    quant_Duncan = quantile(abs(mean(bornes_boot(:,4:5),2) - Duncan_middle) ,1-alp);
    bornesICext(2) = Theil_middle - quant_Theil;
    bornesICext(3) = Theil_middle + quant_Theil;
    bornesICext(4) = Duncan_middle - quant_Duncan;
    bornesICext(5) = Duncan_middle + quant_Duncan;
    % If interior further from the frontier
    bornesICint(2) = 2 * bornes(2) - quantile(bornes_boot(:,2),1-alp);
    bornesICint(3) = 2 * bornes(3) - quantile(bornes_boot(:,3),alp);
    bornesICint(4) = 2 * bornes(4) - quantile(bornes_boot(:,4),1-alp);
    bornesICint(5) = 2 * bornes(5) - quantile(bornes_boot(:,5),alp);
    
    if distance_frontier < 1
        bornesIC = bornesICext;
    else
        bornesIC = bornesICint;
    end
    
    % CI should be between 0 and 1
    bornesIC(2) = max(bornesIC(2),0);
    bornesIC(4) = max(bornesIC(4),0);
    bornesIC(3) = min(bornesIC(3),1);
    bornesIC(5) = min(bornesIC(5),1);
    
end