%
% Test whether the vector m is a vector of moments of a 
%   distribution of probabilities on [0,1]
% Based on the criterion by Krein and Nudel'man
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function contraint = fct_contraint(mchap)
try
    contraint = (max(test_moment(mchap))>=0);
catch
    contraint = 1;
end

function [c,ceq] = test_moment(m)

% Pas de contraintes  l'galit
ceq = 0;

K = length(m);
m_c =[1;m];
k=floor(K/2);

Ak = hankel(m_c(1:k+1),m_c(k+1:2*k+1));
if 2*k<K 
    Bk = hankel(m(1:k+1),m(k+1:2*k+1));
    Ak_Bk = Ak - Bk ;
    c = - [eig(Bk);eig(Ak_Bk)] ;
else
    Bk_1_C = hankel(m(1:k),m(k:2*k-1)) - hankel(m(2:k+1),m(k+1:2*k));
    c = - [eig(Ak);eig(Bk_1_C)];
end    

c= sort(c,'descend');
