%
% Bootstrap test of the binomial mixture model
%  (see online appendix)
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function pval = fct_test_binomiale_bootmv(db, K, B)

k=floor(K/2)+1;

% Gere les donnees
[Ptilde, n] = fct_datamanip(db,K);
Pcomplet = [1-sum(Ptilde);Ptilde];
% mchap est-il dans Mrond    
Q=fct_Q(K);   
mtilde = Q \ Ptilde;
contraint = fct_contraint(mtilde);

% Cas mchap  l'intrieur => on accepte toujours
if contraint == 0
    pval = 1;
% Cas mchap  l'extrieur
else
    % Support initial (rpartition uniforme des K+1 points) 
    xp0 = [(1/(k+1):1/(k+1):(k)/(k+1))';ones(k,1)/k] ;
    xp1 = projection_xp(Ptilde, xp0); 
    [xp1,Pchap2_complet] = projection_maxvrais(Ptilde, xp1); 
    T = 2*sum(xlnx(n*Pcomplet)-(n*Pcomplet).*log(n*Pchap2_complet));

    T_boot = zeros(B,1);

    for bb=1:B

        count_boot = mnrnd(n,Pchap2_complet);

        if count_boot(1)==n %gere le cas count_boot = [n 0 0 0...]
            T_boot(bb) = 0 ;
        else
            Pcomplet_boot = count_boot'/n;
            Pchap_boot = Pcomplet_boot(2:end);
            mchap_boot = Q \ Pchap_boot;
            contraint_boot = fct_contraint(mchap_boot);

            if contraint_boot == 0
                T_boot(bb) = 0;
            else
                [~,Pchap2_complet_boot] = projection_maxvrais(Pchap_boot, xp1); 
                T_boot(bb) = 2*sum(xlnx(n*Pcomplet_boot)-(n*Pcomplet_boot).*log(n*Pchap2_complet_boot));
            end
        end
        
    end
    
    pval = mean(T<T_boot);
    
end
