%
% Moments of truncated normal distribution
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function mom=moment_normale_trans(msig, Kmax)


m = msig(1);
sig= msig(2);

mom =zeros(Kmax,1);

for k=1:Kmax
    mom(k) = integral(@(x) (x.^k).*fp(x,m, sig),0,1,'RelTol',0,'AbsTol',1e-12);
end

end

function res = fp(x,mu, sig)

res = normpdf(norminv(x,0,1),mu,sig)./normpdf(norminv(x,0,1),0,1);

end
