%
% Projection of the estimated P on the space corresponding to \mathcal M
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function [xp1,Pchap2_complet,distance] = projection_xp(Pchap, xp0)

opts = optimset('fmincon');
opts4 = optimset(opts,'Display','off','MaxIter',2000,'MaxFunEvals',50000,'TolCon',1e-7,'Algorithm','sqp');

K = length(Pchap);
W = eye(K);%fct_W(Pchap);
Q = fct_Q(K);
k = length(xp0)/2;

% Pour taille k
% Contraintes sur les x : suite croissante, positive et <= 1
% + contraites sur les p : p>0
Ad = [ [[-1,zeros(1,k-1)];eye(k) - diag(ones(k-1,1),1)] zeros(k+1,k); zeros(k,k) (-eye(k))]; 
bd = [[-1e-6;-2e-2 * ones(k-1,1);1]; -1e-6*ones(k,1)];
% Contrainte sur les p : somment  1
Adeq = [zeros(1,k) ones(1,k)];
bdeq = 1;    

if nargout <3
    [xp1,~,exit] = fmincon(@(xp) distpchap(xp, Pchap, W, Q), xp0, Ad, bd, Adeq, bdeq,[],[],[],opts4);
    if exit < 1
        xp1 = fmincon(@(xp) distpchap(xp, Pchap, W, Q), xp1 , Ad, bd, Adeq, bdeq,[],[],[],opts4);
    end
else
    [xp1,distance,exit] = fmincon(@(xp) distpchap(xp, Pchap, W, Q), xp0, Ad, bd, Adeq, bdeq,[],[],[],opts4);
    if exit < 1
        [xp1,distance] = fmincon(@(xp) distpchap(xp, Pchap, W, Q), xp1 , Ad, bd, Adeq, bdeq,[],[],[],opts4);
    end
end

% for j=1:5
%      xp_init = [sort(rand(k,1));ones(k,1)/k] ;
%      [xp1,fval,exit] = fmincon(@(xp) distpchap(xp, Pchap, W, Q), xp_init, Ad, bd, Adeq, bdeq,[],[],[],opts4)
% end
Pchap2_complet = fct_Pcomplet(xp1,K);
end 

function [val] = distpchap(xp,pchap,W,Q)

K = size(Q,2);
k = length(xp)/2;
x = xp(1:k);
p = xp(k+1:end);
A =  (ones(K,1) * x' ).^((1:K)' * ones(1,k));
val = (Q*A*p - pchap)'*W*(Q*A*p - pchap);

end

