%
% Computes true indices of a truncated normal 
% Updated May 2016
% Xavier d'Haultfoeuille, Roland Rathelot
% 

function [vrai_Theil vrai_Duncan vrai_coworker]= vrai_param(msig0)

%msig0 = [-3.26;1.46];
m = moment_normale_trans(msig0,2);  
m01 = m(1);
m02 = m(2);
mu = msig0(1);
sig = msig0(2);
vrai_Theil = 1- quad(@(x) xlnxfp(x,mu,sig),0,1)/(m01*log(m01));
vrai_Duncan = 0.5*quad(@(x) Duncfp(x,mu,sig,m01),0,1)/(m01*(1-m01));
vrai_coworker = (m02-m01^2)/m01/(1-m01);

end


function res = fp(x,mu, sig)

res = normpdf(norminv(x,0,1),mu,sig)./normpdf(norminv(x,0,1),0,1);

end

function res = xlnxfp(x,mu,sig) 

res = fp(x,mu, sig).* xlnx(x);

end


function res = Duncfp(x,mu,sig,m01) 

res = fp(x,mu, sig).* abs(x-m01);

end